CON

  x_tiles = 16
  y_tiles = 12

  paramcount = 14       
  bitmap_base = $2000
  display_base = $5000

VAR
  word  screen[x_tiles * y_tiles]
  long  colors[64]

DAT
tv_status     long    0         '0/1/2 = off/visible/invisible             read-only
tv_enable     long    1         '0/? = off/on                              write-only

'Use this for the Propeller DEMO board:
'tv_pins       long    %001_0101 '%ppmmm = pins                             write-only

'Use this for the DC20 Parallax badge:
tv_pins       long    %011_0000 '%ppmmm = pins                             write-only

tv_mode       long    %0000     '%ccinp = chroma,interlace,ntsc/pal,swap   write-only
tv_screen     long    0         'pointer to screen (words)                 write-only
tv_colors     long    0         'pointer to colors (longs)                 write-only
tv_hc         long    x_tiles   'horizontal cells                          write-only
tv_vc         long    y_tiles   'vertical cells                            write-only
tv_hx         long    7 '10     'horizontal cell expansion                 write-only
tv_vx         long    1         'vertical cell expansion                   write-only
tv_ho         long    0         'horizontal offset                         write-only
tv_vo         long    0         'vertical offset                           write-only
tv_broadcast  long    0         'broadcast frequency (Hz)                  write-only
tv_auralcog   long    0         'aural fm cog                              write-only

''Note: tv_hx = 7 is the correct aspect ratio on the Philips display

OBJ
  tv            : "tv"
PUB Start|i,dx,dy
    'start tv
    tv_screen := @screen
    tv_colors := @colors
    tv.start(@tv_status)
    'init colors
    repeat i from 0 to 63
      colors[i] := $07_6C_6D_2B
   'init tile screen
    repeat dx from 0 to tv_hc - 1
      repeat dy from 0 to tv_vc - 1
        screen[dy * tv_hc + dx] := display_base >> 6 + dy + dx * tv_vc + ((dy & $3F) << 10)
  